
{$APPTYPE GUI}{$MODE DELPHI}

program demo80;

uses
  SysUtils,windows,math,gl,glu,GraphOGL,GOGL_Collision;

//const
 
type
  TQuad = record
    p1,p2,p3,p4:TGLVector;
  end;

var 
  i,l,m:integer;
  q:array[0..10]of TQuad;
  p1,p2,p,tmp:TGLVector;
  tmep,tmep1:TGLVector;
  pos1,pos2,pp:array[0..7,0..7]of TGLVector;
  rot,size:array[0..7,0..7]of glfloat;
  CheckColl:boolean = false;
  debug:boolean = false;  
  
  
   
//{$R *.rc}
//{$R *.res}  
 
 
procedure Quad(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,tu,tv:glFloat);
begin
  TwoSideON;
  glDisable(GL_CULL_FACE);
  glBegin(GL_QUADS);
   FindNormal(x2,y2,z2,x1,y1,z1,x3,y3,z3);
   glNormal3f(FNormal[1], FNormal[2], FNormal[3]);
	LineFree((x2-x1+1)*tu,(z4-z1+1)*tv, 0,(z4-z1+1)*tv, x2,y2,z2, x1,y1,z1,true);
	LineFree(0,0, (x2-x1+1)*tu,0, x3,y3,z3, x4,y4,z4,true);	
  glEnd;
  glEnable(GL_CULL_FACE);
  TwoSideOFF;  
end; 


function GetRayHigh(OffSet,intersection,MaxHigh:glfloat):glfloat;
begin
  result:=OffSet-(OffSet-intersection)+MaxHigh;
end;


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
  TextureLoadID('wall02.bmp',0);
  TextureLoadID('stoneblocks.bmp',1);  
  TextureLoadTGAID('erba01.tga',0);
  
end;
begin 

  OpenGL_Texture();
  
  // punti raggio
  p1:=glvector(0,-1,0);
  p2:=glvector(0,15,0);  
  
  // punti quadrilateri 
  q[0].p1:=glvector(-10,0,-10); q[0].p2:=glvector(10,0,-10); q[0].p3:=glvector(-10,0,10); q[0].p4:=glvector(10,0,10);
  q[1].p1:=glvector(-6,0,10);   q[1].p2:=glvector(0,4,10);   q[1].p3:=glvector(-6,0,6);   q[1].p4:=glvector(0,4,6);
  q[2].p1:=glvector(0,4,10);    q[2].p2:=glvector(10,4,10);  q[2].p3:=glvector(0,4,6);    q[2].p4:=glvector(10,4,6);
  q[3].p1:=glvector(10,4,6);    q[3].p2:=glvector(10,4,-10); q[3].p3:=glvector(6,4,6);    q[3].p4:=glvector(6,4,-10); 
  q[4].p1:=glvector(-10,4,-10); q[4].p2:=glvector(6,4,-10);  q[4].p3:=glvector(-10,4,-2); q[4].p4:=glvector(6,4,-2);  
  q[5].p1:=glvector(-10,4,10);  q[5].p2:=glvector(-10,4,-2); q[5].p3:=glvector(-6,4,10);  q[5].p4:=glvector(-6,4,-2); 
  q[6].p1:=glvector(6,4,-10);   q[6].p2:=glvector(0,8,-10);  q[6].p3:=glvector(6,4,-6);   q[6].p4:=glvector(0,8,-6); 
  q[7].p1:=glvector(-10,8,-10); q[7].p2:=glvector(0,8,-10);  q[7].p3:=glvector(-10,8,-6); q[7].p4:=glvector(0,8,-6);
  
  // posizioni piante
  for i:=0 to 6 do for l:=0 to 6 do
  begin
   pos1[i,l]:=glvector(9-random(18),-1,9-random(18));
   pos2[i,l]:=glvector(pos1[i,l].x,10,pos1[i,l].z);
   //rot[i,l]:=180-random(360);
   size[i,l]:=1+random*0.75;
  end;
  
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  OpenGL_Init(100,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
  
  if not CheckColl then
  begin
   if SetglKey('S')then if p1.z<10-1 then begin p1.z:=p1.z+0.1;p2.z:=p2.z+0.1;end;
   if SetglKey('W')then if p1.z>-10+1 then begin p1.z:=p1.z-0.1;p2.z:=p2.z-0.1;end;
   if SetglKey('D')then if p1.x<10-1 then begin p1.x:=p1.x+0.1;p2.x:=p2.x+0.1;end;
   if SetglKey('A')then if p1.x>-10+1 then begin p1.x:=p1.x-0.1;p2.x:=p2.x-0.1;end;
  end;
  
  if SetglKey('S')and CheckColl then begin p1.z:=p1.z-0.25;p2.z:=p2.z-0.25;end;
  if SetglKey('W')and CheckColl then begin p1.z:=p1.z+0.25;p2.z:=p2.z+0.25;end;
  if SetglKey('D')and CheckColl then begin p1.x:=p1.x-0.25;p2.x:=p2.x-0.25;end;
  if SetglKey('A')and CheckColl then begin p1.x:=p1.x+0.25;p2.x:=p2.x+0.25;end;   
  
  if SetglKey('Z')then debug:=not(debug);
  
end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,-3,-30);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(25,1,0,0); 
  
  SetglMouseMove(GL_M0,2);    
  
  PutglPointLight(GL_LIGHT0,0, 0,10,5, 0.1); 
  
  // rilevamento dell'altezza tramite intersezione di un raggio
  for i:=0 to 7 do LineInQuad(p1,tmep, q[i].p1,q[i].p2,q[i].p3,q[i].p4, p);
  tmep:=glvector(p2.x,GetRayHigh(p2.y,p.y,2),p2.z); 
  
  // collisione rilevamento tramite intersezione di un raggio
  if LineInQuad(tmep,tmep1, q[0].p1,q[0].p2,q[0].p3,q[0].p4, tmp)
  or LineInQuad(tmep,tmep1, q[1].p1,q[1].p2,q[1].p3,q[1].p4, tmp)
  or LineInQuad(tmep,tmep1, q[2].p1,q[2].p2,q[2].p3,q[2].p4, tmp)
  or LineInQuad(tmep,tmep1, q[3].p1,q[3].p2,q[3].p3,q[3].p4, tmp)
  or LineInQuad(tmep,tmep1, q[4].p1,q[4].p2,q[4].p3,q[4].p4, tmp)
  or LineInQuad(tmep,tmep1, q[5].p1,q[5].p2,q[5].p3,q[5].p4, tmp)
  or LineInQuad(tmep,tmep1, q[6].p1,q[6].p2,q[6].p3,q[6].p4, tmp)
  or LineInQuad(tmep,tmep1, q[7].p1,q[7].p2,q[7].p3,q[7].p4, tmp)then CheckColl:=true else CheckColl:=false;
  tmep1:=glvector(tmep.x,tmep.y+0.25,tmep.z);
  
  // rilevamento dell'altezza delle piante tramite intersezione di un raggio
  for i:=0 to 6 do for l:=0 to 6 do
  for m:=0 to 7 do LineInQuad(pos1[i,l],pos2[i,l], q[m].p1,q[m].p2,q[m].p3,q[m].p4, pp[i,l]);
 // tmep:=glvector(pos2[i,l].x,GetRayHigh(p2.y,p.y,2),p2.z);   
  
  // creazione dell'ambiente  
  TextureSelectID(0);
  with q[0]do Quad(p1.x,p1.y,p1.z, p2.x,p2.y,p2.z, p3.x,p3.y,p3.z, p4.x,p4.y,p4.z, 0.2,0.2); 
  TextureSelectID(1);
  for i:=1 to 2 do with q[i]do Quad(p1.x,p1.y,p1.z, p2.x,p2.y,p2.z, p3.x,p3.y,p3.z, p4.x,p4.y,p4.z, 0.3,0.6);
  with q[3]do Quad(p1.x,p1.y,p1.z, p2.x,p2.y,p2.z, p3.x,p3.y,p3.z, p4.x,p4.y,p4.z, 5,0.1); 
  with q[4]do Quad(p1.x,p1.y,p1.z, p2.x,p2.y,p2.z, p3.x,p3.y,p3.z, p4.x,p4.y,p4.z, 0.3,0.3);
  with q[5]do Quad(p1.x,p1.y,p1.z, p2.x,p2.y,p2.z, p3.x,p3.y,p3.z, p4.x,p4.y,p4.z, 3.5,0.1); 
  for i:=6 to 7 do with q[i]do Quad(p1.x,p1.y,p1.z, p2.x,p2.y,p2.z, p3.x,p3.y,p3.z, p4.x,p4.y,p4.z, 0.4,0.35); 
 
  // giocatore
   TextureOFF; 
  glPushMatrix;
  glTranslatef(p.x,p.y+1,p.z);    
  glRotatef(90,1,0,0); 
  Sfera(0,0,0, 1,20,20, 1/3);
  glPopMatrix; 
  TextureON; 
  
  // piante
  SetglSprite;
  TextureTGASelectID(0);
  for i:=0 to 5 do for l:=0 to 5 do
  begin
   BillboardBegin(pp[i,l].x,pp[i,l].y,pp[i,l].z);
   //glRotatef(rot[i,l],0,1,0);
   glScalef(size[i,l],size[i,l],size[i,l]);   
   Quad(-1,1*2,0, 1,1*2,0, -1,0,0, 1,0,0, 1/3,1); 
   BillboardEnd;
  end;
  SetglSpriteOFF;
  
  // debug	
  if debug then
  begin
   TextureOFF;  
   LightingOFF;
   glColor3f(0.5,0.5,0);
   Line(p1.x,p1.y,p1.z, tmep.x,tmep.y,tmep.z);
   glColor3f(0,0.5,0);
   Line(tmep.x,tmep.y,tmep.z, tmep1.x,tmep1.y,tmep1.z); 
   glColor3f(0.5,0,0);
   for i:=0 to 6 do for l:=0 to 6 do
   Line(pos1[i,l].x,pos1[i,l].y,pos1[i,l].z, pos2[i,l].x,pos2[i,l].y,pos2[i,l].z);
   LightingON;	
   TextureON;  
  end;
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Rilevamento dell altezza tramite intersezioni con i raggi - W\S\A\D movimento  Z on/off debug', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(100,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
